Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/PermutationDiversityCalculator.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/PermutationDiversityCalculator.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/PermutationDiversityCalculator.cs	(revision 7775)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using System.Linq;
 using HeuristicLab.Common;
@@ -42,15 +43,17 @@
     }
 
-    protected override int CalculateDiversity(IItem left, IItem right) {
+    protected override double CalculateDiversity(IItem left, IItem right) {
+      if (!(left is Permutation) || !(right is Permutation))
+        throw new ArgumentException("Cannot calculate diversity because one of the provided objects or both have the wrong type.");
+
       var v1 = left as Permutation;
       var v2 = right as Permutation;
-      int diversity = 0;
-      if (v1 != null && v2 != null)
-        for (int i = 0; i < v1.Length; i++) {
-          var node = v2.Select((x, index) => new { Value = x, ValueIndex = index }).First(x => x.Value == v1[i]);
-          var pred = v2[(node.ValueIndex - 1 + v2.Length) % v2.Length];
-          var succ = v2[(node.ValueIndex + 1 % v2.Length) % v2.Length];
-          if (new[] { pred, succ }.All(x => x != v1[(i + 1) % v1.Length])) diversity++;
-        }
+      double diversity = 0.0;
+      for (int i = 0; i < v1.Length; i++) {
+        var node = v2.Select((x, index) => new { Value = x, ValueIndex = index }).First(x => x.Value == v1[i]);
+        var pred = v2[(node.ValueIndex - 1 + v2.Length) % v2.Length];
+        var succ = v2[(node.ValueIndex + 1) % v2.Length];
+        if (new[] { pred, succ }.All(x => x != v1[(i + 1) % v1.Length])) diversity++;
+      }
       return diversity;
     }
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanImprovementOperator.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanImprovementOperator.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanImprovementOperator.cs	(revision 7775)
@@ -138,11 +138,11 @@
 
       for (int i = 0; i < ImprovementAttempts.Value; i++) {
-        int a = Random.Next(currSol.Length - 1);
-        int b = Random.Next(currSol.Length - 1);
+        int a = Random.Next(currSol.Length);
+        int b = Random.Next(currSol.Length);
         Invert(currSol, a, b);
         currLength = TSPEuclideanPathEvaluator.Apply(Evaluator as TSPCoordinatesPathEvaluator, Coordinates, currSol);
         if (currLength < bestLength) {
           bestLength = currLength;
-          bestSol = (Permutation)currSol.Clone();
+          bestSol = currSol.Clone() as Permutation;
         }
         Invert(currSol, a, b);
@@ -155,11 +155,12 @@
 
     private void Invert(Permutation sol, int i, int j) {
-      if (i != j) {
-        for (int a = 0; a < Math.Abs(i - j) / 2; a++) {
-          int tmp = sol[(i + a) % sol.Length];
-          sol[(i + a) % sol.Length] = sol[(j - a + sol.Length) % sol.Length];
-          sol[(j - a + sol.Length) % sol.Length] = tmp;
-        }
-      }
+      if (i != j)
+        for (int a = 0; a < Math.Abs(i - j) / 2; a++)
+          if (sol[(i + a) % sol.Length] != sol[(j - a + sol.Length) % sol.Length]) {
+            // XOR swap
+            sol[(i + a) % sol.Length] ^= sol[(j - a + sol.Length) % sol.Length];
+            sol[(j - a + sol.Length) % sol.Length] ^= sol[(i + a) % sol.Length];
+            sol[(i + a) % sol.Length] ^= sol[(j - a + sol.Length) % sol.Length];
+          }
     }
   }
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanMultipleGuidesPathRelinker.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanMultipleGuidesPathRelinker.cs	(revision 7775)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanMultipleGuidesPathRelinker.cs	(revision 7775)
@@ -0,0 +1,130 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.TravelingSalesman;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.TravelingSalesman {
+  /// <summary>
+  /// An operator that relinks paths between traveling salesman solutions using a multiple guiding strategy.
+  /// </summary>
+  [Item("TravelingSalesmanMultipleGuidingPathRelinker", "An operator that relinks paths between traveling salesman solutions using a multiple guiding strategy.")]
+  [StorableClass]
+  public sealed class TravelingSalesmanMultipleGuidesPathRelinker : PathRelinker {
+    #region Parameter properties
+    public ILookupParameter<DistanceMatrix> DistanceMatrixParameter {
+      get { return (ILookupParameter<DistanceMatrix>)Parameters["DistanceMatrix"]; }
+    }
+    #endregion
+
+    #region Properties
+    public DistanceMatrix DistanceMatrix {
+      get { return DistanceMatrixParameter.ActualValue; }
+      set { DistanceMatrixParameter.ActualValue = value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private TravelingSalesmanMultipleGuidesPathRelinker(bool deserializing) : base(deserializing) { }
+    private TravelingSalesmanMultipleGuidesPathRelinker(TravelingSalesmanMultipleGuidesPathRelinker original, Cloner cloner) : base(original, cloner) { }
+    public TravelingSalesmanMultipleGuidesPathRelinker()
+      : base() {
+      #region Create parameters
+      Parameters.Add(new LookupParameter<DistanceMatrix>("DistanceMatrix"));
+      #endregion
+      ParentsParameter.ActualName = "TSPTour";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TravelingSalesmanMultipleGuidesPathRelinker(this, cloner);
+    }
+
+    public static ItemArray<IItem> Apply(IItem initiator, IItem[] guides, DistanceMatrix distances, PercentValue n) {
+      if (!(initiator is Permutation) || guides.Any(x => !(x is Permutation)))
+        throw new ArgumentException("Cannot relink path because some of the provided solutions have the wrong type.");
+      if (n.Value <= 0.0)
+        throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
+
+      var v1 = initiator.Clone() as Permutation;
+      var targets = new Permutation[guides.Length];
+      Array.Copy(guides, targets, guides.Length);
+
+      if (targets.Any(x => x.Length != v1.Length))
+        throw new ArgumentException("At least one solution is of different length.");
+
+      var solutions = new List<Permutation>();
+      for (int i = 0; i < v1.Length; i++) {
+        var currCityIndex = i;
+        var bestCityIndex = (i + 1) % v1.Length;
+        var currDistance = distances[v1[currCityIndex], v1[bestCityIndex]];
+        targets.ToList().ForEach(solution => {
+          var node = solution.Select((x, index) => new { Id = x, Index = index }).First(x => x.Id == v1[currCityIndex]);
+          var pred = solution[(node.Index - 1 + solution.Length) % solution.Length];
+          var succ = solution[(node.Index + 1) % solution.Length];
+          var results = new[] { pred, succ }.Select(x => new { Id = x, Distance = distances[x, node.Id] });
+          if (results.Any(x => x.Distance < currDistance)) {
+            var bestCity = results.OrderBy(x => x.Distance).First();
+            bestCityIndex = v1.Select((x, index) => new { Id = x, Index = index }).First(x => x.Id == bestCity.Id).Index;
+            currDistance = bestCity.Distance;
+          }
+        });
+        Invert(v1, i, bestCityIndex);
+        solutions.Add(v1.Clone() as Permutation);
+      }
+
+      var selection = new List<IItem>();
+      if (solutions.Count > 0) {
+        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        if (noSol <= 0) noSol++;
+        var stepSize = (double)solutions.Count / (double)noSol;
+        for (int i = 0; i < noSol; i++)
+          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
+      }
+
+      return new ItemArray<IItem>(selection);
+    }
+
+    private static void Invert(Permutation sol, int i, int j) {
+      if (i != j)
+        for (int a = 0; a < Math.Abs(i - j) / 2; a++)
+          if (sol[(i + a) % sol.Length] != sol[(j - a + sol.Length) % sol.Length]) {
+            // XOR swap
+            sol[(i + a) % sol.Length] ^= sol[(j - a + sol.Length) % sol.Length];
+            sol[(j - a + sol.Length) % sol.Length] ^= sol[(i + a) % sol.Length];
+            sol[(i + a) % sol.Length] ^= sol[(j - a + sol.Length) % sol.Length];
+          }
+    }
+
+    protected override ItemArray<IItem> Relink(ItemArray<IItem> parents, PercentValue n) {
+      if (parents.Length != 2)
+        throw new ArgumentException("The number of parents is not equal to 2.");
+      return Apply(parents[0], parents.Skip(1).ToArray(), DistanceMatrix, n);
+    }
+  }
+}
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanPathRelinker.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanPathRelinker.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanPathRelinker.cs	(revision 7775)
@@ -49,28 +49,35 @@
 
     public static ItemArray<IItem> Apply(IItem initiator, IItem guide, PercentValue n) {
+      if (!(initiator is Permutation) || !(guide is Permutation))
+        throw new ArgumentException("Cannot relink path because one of the provided solutions or both have the wrong type.");
+      if (n.Value <= 0.0)
+        throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
+
       var v1 = initiator.Clone() as Permutation;
       var v2 = guide as Permutation;
 
       if (v1.Length != v2.Length)
-        throw new ArgumentException("TravelingSalesmanPathRelinker: The solutions are of different length.");
-      if (n.Value == 0.0)
-        throw new ArgumentException("TravelingSalesmanPathRelinker: RelinkingAccuracy is 0.");
+        throw new ArgumentException("The solutions are of different length.");
 
       var solutions = new List<Permutation>();
-      for (int i = 0; i < v1.Length; i++) {
+      for (int i = 0; i < v1.Length; i++)
         if (v1[i] != v2[i]) {
           var target = v1.Select((x, index) => new { Value = x, ValueIndex = index }).First(x => x.Value == v2[i]);
-          // XOR swap
-          v1[i] ^= v1[target.ValueIndex];
-          v1[target.ValueIndex] ^= v1[i];
-          v1[i] ^= v1[target.ValueIndex];
-          solutions.Add((Permutation)v1.Clone());
+          if (v1[i] != v1[target.ValueIndex]) {
+            // XOR swap
+            v1[i] ^= v1[target.ValueIndex];
+            v1[target.ValueIndex] ^= v1[i];
+            v1[i] ^= v1[target.ValueIndex];
+            solutions.Add(v1.Clone() as Permutation);
+          }
         }
-      }
 
-      var stepSize = 1 / n.Value;
       var selection = new List<IItem>();
-      for (int i = 0; i < solutions.Count; i = (int)Math.Round(i + stepSize)) {
-        selection.Add(solutions.ElementAt(i));
+      if (solutions.Count > 0) {
+        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        if (noSol <= 0) noSol++;
+        var stepSize = (double)solutions.Count / (double)noSol;
+        for (int i = 0; i < noSol; i++)
+          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
       }
 
@@ -79,5 +86,6 @@
 
     protected override ItemArray<IItem> Relink(ItemArray<IItem> parents, PercentValue n) {
-      if (parents.Length != 2) throw new ArgumentException("TravelingSalesmanPathRelinker: The number of parents is not equal to 2.");
+      if (parents.Length != 2)
+        throw new ArgumentException("The number of parents is not equal to 2.");
       return Apply(parents[0], parents[1], n);
     }
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanSimultaneousPathRelinker.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanSimultaneousPathRelinker.cs	(revision 7775)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanSimultaneousPathRelinker.cs	(revision 7775)
@@ -0,0 +1,103 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.TravelingSalesman {
+  /// <summary>
+  /// An operator that relinks paths between traveling salesman solutions starting from both ends.
+  /// </summary>
+  [Item("TravelingSalesmanSimultaneousPathRelinker", "An operator that relinks paths between traveling salesman solutions starting from both ends.")]
+  [StorableClass]
+  public sealed class TravelingSalesmanSimultaneousPathRelinker : PathRelinker {
+    [StorableConstructor]
+    private TravelingSalesmanSimultaneousPathRelinker(bool deserializing) : base(deserializing) { }
+    private TravelingSalesmanSimultaneousPathRelinker(TravelingSalesmanSimultaneousPathRelinker original, Cloner cloner) : base(original, cloner) { }
+    public TravelingSalesmanSimultaneousPathRelinker()
+      : base() {
+      ParentsParameter.ActualName = "TSPTour";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TravelingSalesmanSimultaneousPathRelinker(this, cloner);
+    }
+
+    public static ItemArray<IItem> Apply(IItem initiator, IItem guide, PercentValue n) {
+      if (!(initiator is Permutation) || !(guide is Permutation))
+        throw new ArgumentException("Cannot relink path because one of the provided solutions or both have the wrong type.");
+      if (n.Value <= 0.0)
+        throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
+
+      var firstInitiator = initiator.Clone() as Permutation;
+      var firstGuide = guide.Clone() as Permutation;
+      var secondInitiator = firstGuide.Clone() as Permutation;
+      var secondGuide = firstInitiator.Clone() as Permutation;
+
+      if (firstInitiator.Length != firstGuide.Length)
+        throw new ArgumentException("The solutions are of different length.");
+
+      var solutions = new List<Permutation>();
+      for (int i = 0; i < firstInitiator.Length / 2; i++) {
+        if (firstInitiator[i] != firstGuide[i]) {
+          var target = firstInitiator.Select((x, index) => new { Value = x, ValueIndex = index }).First(x => x.Value == firstGuide[i]);
+          // XOR swap
+          firstInitiator[i] ^= firstInitiator[target.ValueIndex];
+          firstInitiator[target.ValueIndex] ^= firstInitiator[i];
+          firstInitiator[i] ^= firstInitiator[target.ValueIndex];
+          solutions.Add(firstInitiator.Clone() as Permutation);
+        }
+        var j = secondInitiator.Length - 1 - i;
+        if (secondInitiator[j] != secondGuide[j]) {
+          var target = secondInitiator.Select((x, index) => new { Value = x, ValueIndex = index }).First(x => x.Value == secondGuide[j]);
+          // XOR swap
+          secondInitiator[j] ^= secondInitiator[target.ValueIndex];
+          secondInitiator[target.ValueIndex] ^= secondInitiator[j];
+          secondInitiator[j] ^= secondInitiator[target.ValueIndex];
+          solutions.Add(secondInitiator.Clone() as Permutation);
+        }
+      }
+
+      var selection = new List<IItem>();
+      if (solutions.Count > 0) {
+        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        if (noSol <= 0) noSol++;
+        var stepSize = (double)solutions.Count / (double)noSol;
+        for (int i = 0; i < noSol; i++)
+          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
+      }
+
+      return new ItemArray<IItem>(selection);
+    }
+
+    protected override ItemArray<IItem> Relink(ItemArray<IItem> parents, PercentValue n) {
+      if (parents.Length != 2)
+        throw new ArgumentException("The number of parents is not equal to 2.");
+      return Apply(parents[0], parents[1], n);
+    }
+  }
+}
